rltext = {}
rltext.name = "RaidLeadEssentials"
rltext.savedVariables = {}
rltext.bIsPreview = false
rltext.bIsPositioning = false
rltext.masterList = nil
rltext.player = ""
rltext.lastLead = ""


function rltext:ActiveSettings()
	return self.savedVariables
end

function rltext:OnFontChanged()
	local LMP = LibStub("LibMediaProvider-1.0")
	local nfont = rltext:ActiveSettings().font
	local nfontsize = rltext:ActiveSettings().fontsize
	rltext:_OnFontChanged(nfont, nfontsize)

	nfont = rltext:ActiveSettings().slfont
	nfontsize = rltext:ActiveSettings().slfontsize
	rltext:_OnFontChangedSL(nfont, nfontsize)

	nfont = rltext:ActiveSettings().mfont
	nfontsize = rltext:ActiveSettings().mfontsize
	rltext:_OnFontChangedM(nfont, nfontsize)
end

function rltext:_OnFontChanged(font, size)
	local LMP = LibStub("LibMediaProvider-1.0")
	RLTEXT_OVERLAY_Text:SetFont(LMP:Fetch('font', font).."|"..size.."|"..rltext:ActiveSettings().outline)
end
function rltext:_OnFontChangedSL(font, size)
	local LMP = LibStub("LibMediaProvider-1.0")
	RLTEXT_OVERLAYSEC_Text:SetFont(LMP:Fetch('font', font).."|"..size.."|"..rltext:ActiveSettings().sloutline)
end
function rltext:_OnFontChangedM(font, size)
	local LMP = LibStub("LibMediaProvider-1.0")
	RLTEXT_OVERLAYMEM_Text:SetFont(LMP:Fetch('font', font).."|"..size.."|"..rltext:ActiveSettings().moutline)
end

function rltext:PositionFrame()
	RLTEXT_OVERLAY:SetAnchor(BOTTOM, GuiRoot, CENTER, rltext:ActiveSettings().winLeft, rltext:ActiveSettings().winTop)
end

function rltext:PositionSecFrame()
	RLTEXT_OVERLAYSEC:SetAnchor(BOTTOM, GuiRoot, CENTER, rltext:ActiveSettings().slwinLeft, rltext:ActiveSettings().slwinTop)
end

function rltext:PositionMemFrame()
	RLTEXT_OVERLAYMEM:SetAnchor(BOTTOM, GuiRoot, CENTER, rltext:ActiveSettings().mwinLeft, rltext:ActiveSettings().mwinTop)
end

function rltext:PositionFrames()
	rltext:PositionFrame()
	rltext:PositionMemFrame()
	rltext:PositionSecFrame()
end

function rltext.tableHasValue(tbl,v)
	if #tbl < 1 then return false end
	for _,val in pairs(tbl) do
		if val == v then
			return true
		end
	end
	return false
end

local function tableGetValueId(tbl,v)
	if #tbl < 1 then return 0 end
	for k,val in ipairs(tbl) do
		if val == v then
			return k
		end
	end
	return 0
end

local function wrap(str, adddd, limit, indent, indent1)
  indent = indent or ""
  adddd = adddd or ""
  indent1 = indent1 or indent
  limit = limit or rltext:ActiveSettings().wrapChars
  local here = 1-#indent1
  return indent1..str:gsub("(%s+)()(%S+)()",
						  function(sp, st, word, fi)
							if fi-here > limit then
							  here = st - #indent
							  return "\n"..adddd..indent..word
							end
						  end)
end

function rltext.strsplit(inputstr, sep)
		if sep == nil then
				sep = "%s"
		end
		local t={}
		local i=1
		for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
				t[i] = str
				i = i + 1
		end
		return t
end

function rltext.Preview()

	local color = rltext:ActiveSettings().fontcolor
	color = string.sub(color,1,6)

	local colorname = rltext:ActiveSettings().namecolor
	colorname = string.sub(colorname,1,6)

	--RLTEXT_OVERLAY_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "[Group Leader]").."|c"..color..": "..wrap("Go be awesome!!!!! 123456789 randomletters to make it longer..."))

	RLTEXT_OVERLAY_Icon:SetText("|t32:32:/esoui/art/lfg/lfg_leader_icon.dds|t")
	RLTEXT_OVERLAY_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "[Group Leader]").."|c"..color..": Go be awesome!!!!! 123456789 randomletters to make it longer... 9tuw9ehgise jiosodbön gdsb gsdbgöjdsb jbagjsdb gbowöeIPT ÄS OISDB IGSDOB GIÖO asbjfsakf jksd bu twebsj jlsd fjse jgw sjg vsjyv jw ei nka bweot bibt 230tbsv")
	RLTEXT_OVERLAY_Text:SetDimensions(rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().fontsize/2), 25*(4*4))
	--RLTEXT_OVERLAY_Text:SetClampedToScreen(true)
	RLTEXT_OVERLAY_Text:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
	local twidth = RLTEXT_OVERLAY_Text:GetTextWidth()

	RLTEXT_OVERLAY_Icon:ClearAnchors()
	RLTEXT_OVERLAY_Icon:SetAnchor(TOP, RLTEXT_OVERLAY_Text, TOP, -(((rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().fontsize/2))/2)+16), 0)

 	--<Anchor point="TOP" relativeTo="$(parent)_Icon" relativePoint="TOP" offsetX="32"/>

	color = rltext:ActiveSettings().slfontcolor
	color = string.sub(color,1,6)

	colorname = rltext:ActiveSettings().slnamecolor
	colorname = string.sub(colorname,1,6)



	RLTEXT_OVERLAYSEC_Icon:SetText("|t32:32:ESOUI/art/guild/guild_indexicon_officer_down.dds|t")
	RLTEXT_OVERLAYSEC_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "[Secondary Leader]").."|c"..color..": Go be awesome!!!!! 123456789 randomletters to make it longer... 9tuw9ehgise jiosodbön gdsb gsdbgöjdsb jbagjsdb gbowöeIPT ÄS OISDB IGSDOB GIÖO asbjfsakf jksd bu twebsj jlsd fjse jgw sjg vsjyv jw ei nka bweot bibt 230tbsv")
	RLTEXT_OVERLAYSEC_Text:SetDimensions(rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().slfontsize/2), 25*(4*4))
	RLTEXT_OVERLAYSEC_Text:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
	twidth = RLTEXT_OVERLAYSEC_Text:GetTextWidth()

	RLTEXT_OVERLAYSEC_Icon:ClearAnchors()
	RLTEXT_OVERLAYSEC_Icon:SetAnchor(TOP, RLTEXT_OVERLAYSEC_Text, TOP, -(((rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().slfontsize/2))/2)+16), 0)


	color = rltext:ActiveSettings().mfontcolor
	color = string.sub(color,1,6)

	colorname = rltext:ActiveSettings().mnamecolor
	colorname = string.sub(colorname,1,6)

	RLTEXT_OVERLAYMEM_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "[Random Member]").."|c"..color..": Go be awesome!!!!! 123456789 randomletters to make it longer... 9tuw9ehgise jiosodbön gdsb gsdbgöjdsb jbagjsdb gbowöeIPT ÄS OISDB IGSDOB GIÖO asbjfsakf jksd bu twebsj jlsd fjse jgw sjg vsjyv jw ei nka bweot bibt 230tbsv")
	RLTEXT_OVERLAYMEM_Text:SetDimensions(rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().mfontsize/2), 25*(4*4))
	RLTEXT_OVERLAYMEM_Text:SetHorizontalAlignment(TEXT_ALIGN_LEFT)

	if RLGroupControlWindow:IsHidden() then
		RLGroupControlWindow:SetHidden(false)
		rltext.module.CheckHide()
	end
	local gSize = GetGroupSize()
	if gSize < 2 then
		rltext.UpdateGroup()
		rltext.PreviewAddMember(-1, "Random1")
		rltext.PreviewAddMember(-1, "Random2")
		rltext.PreviewAddMember(-1, "Random3")
		rltext.PreviewAddMember(-1, "Random4")
		rltext.PreviewAddMember(-1, "Random5")
		rltext.PreviewAddMember(-1, "Random6")
		rltext.PreviewAddMember(-1, "Random7")
		rltext.PreviewAddMember(-1, "Random8")
		rltext.PreviewAddMember(-1, "Random9")
		rltext.PreviewAddMember(-1, "Random10")
		rltext.PreviewAddMember(-1, "Random11")
		rltext.PreviewAddMember(-1, "RandomSuperLongName")
		rltext.UpdateList()
	end
end

function rltext.PreviewAddMember(e, memberName)
	rltext.masterList[memberName] = {['cantalk'] = false, ['issec'] = false}
end

function rltext.stopPreview()
	RLTEXT_OVERLAY_Text:SetText("")
	RLTEXT_OVERLAY_Icon:SetText("")
end

function rltext.stopPreviewSL()
	RLTEXT_OVERLAYSEC_Text:SetText("")
	RLTEXT_OVERLAYSEC_Icon:SetText("")
end

function rltext.stopPreviewM()
	RLTEXT_OVERLAYMEM_Text:SetText("")
end

function rltext.stopPreviews()
	rltext.stopPreviewM()
	rltext.stopPreviewSL()
	rltext.stopPreview()
	rltext.UpdateGroup()
	rltext.UpdateList()
	if not(RLGroupControlWindow:IsHidden()) then
		if not(rltext:ActiveSettings().alon) then
			RLGroupControlWindow:SetHidden(true)
			rltext.module.CheckHide()
		end
	end
end


function rltext.HideCheck()
	if rltext:ActiveSettings().disabled then
		RLGroupControlWindow:SetHidden(true)
		rltext.module.CheckHide(true)
		return
	end

	rltext.module.CheckHide()
	local gameMenuHidden = ZO_GameMenu_InGame:IsHidden()
	local isInteractWindowHidden = ZO_InteractWindow:IsHidden()
	local isGamePanelHidden = ZO_KeybindStripControl:IsHidden()
	local crownStoreActive = WINDOW_MANAGER:IsSecureRenderModeEnabled()

	if rltext.bIsPreview then return end

	if crownStoreActive then
		RLGroupControlWindow:SetHidden(true)
		rltext.module.CheckHide(true)
		return
	end

	if not(gameMenuHidden) or not(isGamePanelHidden) then
		RLGroupControlWindow:SetHidden(true)
		rltext.module.CheckHide(true)
	else
		RLGroupControlWindow:SetHidden(false)
		rltext.module.CheckHide(false)
	end


	if GetGroupSize() < 2 then
		RLGroupControlWindow:SetHidden(true)
		rltext.module.CheckHide(true)
	end
end

-- _type
-- 1 = GroupLeader
-- 2 = GroupMember
-- 3 = SecLeader
function rltext.Draw(from, text, _type)
	if _type == 1 then
		local color = rltext:ActiveSettings().fontcolor or "FD7A38FF"
		color = string.sub(color,1,6)

		local colorname = rltext:ActiveSettings().namecolor or "FD7A38FF"
		colorname = string.sub(colorname,1,6)
		

		RLTEXT_OVERLAY_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "["..from.."]").."|c"..color..": "..text)
		RLTEXT_OVERLAY_Icon:SetText("|t32:32:/esoui/art/lfg/lfg_leader_icon.dds|t")
		RLTEXT_OVERLAY_Text:SetDimensions(rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().fontsize/2), 25*(4*4))
		RLTEXT_OVERLAY_Text:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
		RLTEXT_OVERLAY_Icon:ClearAnchors()
		RLTEXT_OVERLAY_Icon:SetAnchor(TOP, RLTEXT_OVERLAY_Text, TOP, -(((rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().fontsize/2))/2)+16), 0)

		local value = rltext:ActiveSettings().ttime
		EVENT_MANAGER:UnregisterForUpdate(rltext.name.."@Update")
		local scanInterval = value * 1000
		EVENT_MANAGER:RegisterForUpdate(rltext.name.."@Update", scanInterval, function()
			if not rltext.bIsPreview and not rltext.bIsPositioning then
				rltext.stopPreview()
			end
		end)

	end


	if _type == 2 then
		local color = rltext:ActiveSettings().mfontcolor or "00FF00FF"
		color = string.sub(color,1,6)

		local colorname = rltext:ActiveSettings().mnamecolor or "00FF00FF"
		colorname = string.sub(colorname,1,6)


		RLTEXT_OVERLAYMEM_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "["..from.."]").."|c"..color..": "..text)
		RLTEXT_OVERLAYMEM_Text:SetDimensions(rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().mfontsize/2), 25*(4*4))
		RLTEXT_OVERLAYMEM_Text:SetHorizontalAlignment(TEXT_ALIGN_LEFT)

		local value = rltext:ActiveSettings().ttime
		EVENT_MANAGER:UnregisterForUpdate(rltext.name.."@mUpdate")
		local scanInterval = value * 1000
		EVENT_MANAGER:RegisterForUpdate(rltext.name.."@mUpdate", scanInterval, function()
			if not rltext.bIsPreview and not rltext.bIsPositioning then
				rltext.stopPreviewM()
			end
		end)

	end

	if _type == 3 then
		local color = rltext:ActiveSettings().slfontcolor or "FF0000FF"
		color = string.sub(color,1,6)

		local colorname = rltext:ActiveSettings().slnamecolor or "FF0000FF"
		colorname = string.sub(colorname,1,6)

		RLTEXT_OVERLAYSEC_Text:SetText("|c"..colorname..zo_strformat("<<t:1>>", "["..from.."]").."|c"..color..": "..text)
		RLTEXT_OVERLAYSEC_Icon:SetText("|t32:32:ESOUI/art/guild/guild_indexicon_officer_down.dds|t")
		RLTEXT_OVERLAYSEC_Text:SetDimensions(rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().slfontsize/2), 25*(4*4))
		RLTEXT_OVERLAYSEC_Text:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
		RLTEXT_OVERLAYSEC_Icon:ClearAnchors()
		RLTEXT_OVERLAYSEC_Icon:SetAnchor(TOP, RLTEXT_OVERLAYSEC_Text, TOP, -(((rltext:ActiveSettings().wrapChars*(rltext:ActiveSettings().slfontsize/2))/2)+16), 0)

		local value = rltext:ActiveSettings().ttime
		EVENT_MANAGER:UnregisterForUpdate(rltext.name.."@slUpdate")
		local scanInterval = value * 1000
		EVENT_MANAGER:RegisterForUpdate(rltext.name.."@slUpdate", scanInterval, function()
			if not rltext.bIsPreview and not rltext.bIsPositioning then
				rltext.stopPreviewSL()
			end
		end)

	end

end


local function OnAddOnLoaded(eventCode, addOnName)
	if addOnName:find('^ZO_') then return end
	if addOnName ~= rltext.name then return end

	SLASH_COMMANDS['/rle'] = rltext.Slash

	local Defaults =  {
		['disabled'] = false,
		['disabledinv'] = false,
		['disabledkik'] = false,
		['savesec'] = true,
		['alon'] = true,
		['font'] = "Arial",
		['slfont'] = "Arial",
		['mfont'] = "Arial",
		['fontcolor'] = "FD7A38FF",
		['namecolor'] = "FD7A38FF",
		['slfontcolor'] = "FF0000FF",
		['slnamecolor'] = "FF0000FF",
		['mfontcolor'] = "00FF00FF",
		['mnamecolor'] = "00FF00FF",
		['outline'] = "outline",
		['sloutline'] = "outline",
		['moutline'] = "outline",
		['fontsize'] = 24,
		['slfontsize'] = 24,
		['mfontsize'] = 24,
		['ttime'] = 5,
		['winLeft'] = 0,
		['winTop'] = -373,
		['slwinLeft'] = 0,
		['slwinTop'] = -284,
		['mwinLeft'] = 0,
		['mwinTop'] = -196,
		['gwinTop'] = 951,
		['gwinLeft'] = 13,
		['gwinSizeX'] = 240,
		['gwinSizeY'] = 300,
		['gwinAlpha'] = 50,
		['wrapChars'] = 72,
		['modules'] = {},
		['savedSec'] = {}
	}


	rltext.savedVariables = ZO_SavedVars:NewAccountWide('RaidLeadEssentialsSavedVars', 1, GetDisplayName(), Defaults)
	

	EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_PLAYER_ACTIVATED, function() 

		EVENT_MANAGER:UnregisterForEvent(rltext.name, EVENT_PLAYER_ACTIVATED )

		--Modules First
		rltext.module:LoadModules()


		rltext:LibAddonInit()

		rltext.player = GetUnitName("player")

		local LMP = LibStub("LibMediaProvider-1.0")
		LMP:Register('font', 'Sansita One',					'RaidLeadEssentials/fonts/SansitaOne.ttf')
		LMP:Register('font', 'Arial',						'RaidLeadEssentials/fonts/arial.ttf')
		LMP:Register('font', 'Cartographer',				'RaidLeadEssentials/fonts/Cartographer.ttf')
		LMP:Register('font', 'Almendra-Bold',				'RaidLeadEssentials/fonts/Almendra-Bold.otf')
		LMP:Register('font', 'AquilineTwo',					'RaidLeadEssentials/fonts/AquilineTwo.ttf')
		LMP:Register('font', 'Bellota-Bold',				'RaidLeadEssentials/fonts/Bellota-Bold.otf')
		LMP:Register('font', 'Felipa-Regular',				'RaidLeadEssentials/fonts/Felipa-Regular.otf')
		LMP:Register('font', 'FLORLRG',						'RaidLeadEssentials/fonts/FLORLRG_.ttf')
		LMP:Register('font', 'Kingthings Calligraphica',	'RaidLeadEssentials/fonts/Kingthings_Calligraphica_2.ttf')
		LMP:Register('font', 'SF Collegiate',				'RaidLeadEssentials/fonts/SF_Collegiate.ttf')

		RLTEXT_OVERLAY:SetMovable(false)
		RLTEXT_OVERLAY:SetMouseEnabled(false)
		RLTEXT_OVERLAY_BG:SetAnchorFill(RLTEXT_OVERLAY)
		RLTEXT_OVERLAY_BG:SetCenterColor(0, 0, 0, 1)
		RLTEXT_OVERLAY_BG:SetEdgeColor(0, 0, 0, 1)
		RLTEXT_OVERLAY_BG:SetEdgeTexture('', 8, 8, 1, 0)
		RLTEXT_OVERLAY_BG:SetInsets(0,0,0,0)
		RLTEXT_OVERLAY_BG:SetAlpha(0)
		RLTEXT_OVERLAYSEC:SetMovable(false)
		RLTEXT_OVERLAYSEC:SetMouseEnabled(false)
		RLTEXT_OVERLAYSEC_BG:SetAnchorFill(RLTEXT_OVERLAYSEC)
		RLTEXT_OVERLAYSEC_BG:SetCenterColor(0, 0, 0, 1)
		RLTEXT_OVERLAYSEC_BG:SetEdgeColor(0, 0, 0, 1)
		RLTEXT_OVERLAYSEC_BG:SetEdgeTexture('', 8, 8, 1, 0)
		RLTEXT_OVERLAYSEC_BG:SetInsets(0,0,0,0)
		RLTEXT_OVERLAYSEC_BG:SetAlpha(0)
		RLTEXT_OVERLAYMEM:SetMovable(false)
		RLTEXT_OVERLAYMEM:SetMouseEnabled(false)
		RLTEXT_OVERLAYMEM_BG:SetAnchorFill(RLTEXT_OVERLAYMEM)
		RLTEXT_OVERLAYMEM_BG:SetCenterColor(0, 0, 0, 1)
		RLTEXT_OVERLAYMEM_BG:SetEdgeColor(0, 0, 0, 1)
		RLTEXT_OVERLAYMEM_BG:SetEdgeTexture('', 8, 8, 1, 0)
		RLTEXT_OVERLAYMEM_BG:SetInsets(0,0,0,0)
		RLTEXT_OVERLAYMEM_BG:SetAlpha(0)
		RLTEXT_OVERLAY:SetClampedToScreen(true)
		RLTEXT_OVERLAY:SetHandler("OnMoveStop", function(self)
				if not(rltext.bIsPositioning) then return end
				local addOnX, addOnY = self:GetCenter()
				local guiRootX, guiRootY = GuiRoot:GetCenter()
				local x = addOnX - guiRootX
				local y = addOnY - guiRootY

				rltext:ActiveSettings().winLeft = x
				rltext:ActiveSettings().winTop = y+25
				self:ClearAnchors()
				rltext:PositionFrames()
			end)
		RLTEXT_OVERLAYSEC:SetClampedToScreen(true)
		RLTEXT_OVERLAYSEC:SetHandler("OnMoveStop", function(self)
				if not(rltext.bIsPositioning) then return end
				local addOnX, addOnY = self:GetCenter()
				local guiRootX, guiRootY = GuiRoot:GetCenter()
				local x = addOnX - guiRootX
				local y = addOnY - guiRootY

				rltext:ActiveSettings().slwinLeft = x
				rltext:ActiveSettings().slwinTop = y+25
				self:ClearAnchors()
				rltext:PositionFrames()
			end)
		RLTEXT_OVERLAYMEM:SetClampedToScreen(true)
		RLTEXT_OVERLAYMEM:SetHandler("OnMoveStop", function(self)
				if not(rltext.bIsPositioning) then return end
				local addOnX, addOnY = self:GetCenter()
				local guiRootX, guiRootY = GuiRoot:GetCenter()
				local x = addOnX - guiRootX
				local y = addOnY - guiRootY

				rltext:ActiveSettings().mwinLeft = x
				rltext:ActiveSettings().mwinTop = y+25
				self:ClearAnchors()
				rltext:PositionFrames()
			end)


		EVENT_MANAGER:RegisterForUpdate(rltext.name.."@Update", 3000000000, function()
		end)
		EVENT_MANAGER:RegisterForUpdate(rltext.name.."@slUpdate", 3000000000, function()
		end)
		EVENT_MANAGER:RegisterForUpdate(rltext.name.."@mUpdate", 3000000000, function()
		end)

		ZO_PreHookHandler(ZO_GameMenu_InGame, "OnShow", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_GameMenu_InGame, "OnHide", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_InteractWindow, "OnShow", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_InteractWindow, "OnHide", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_KeybindStripControl, "OnShow", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_KeybindStripControl, "OnHide", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_MainMenuCategoryBar, "OnShow", function() zo_callLater(rltext.HideCheck,10) end)
		ZO_PreHookHandler(ZO_MainMenuCategoryBar, "OnHide", function() zo_callLater(rltext.HideCheck,10) end)


		rltext.masterList = {}

		rltext:OnFontChanged()
		rltext:PositionFrames()
		rltext:WinInit()

		rltext.InitialUpdate()

		rltext.HideCheck()

	end)

end

function rltext.Slash(args)
	if args == 'help' then
		msg("/rle on/off - Toggle RLE")
		return
	end
	if args == 'sec' then
		rltext.PrintSec()
		return
	end
	if args == "on" or args == "off" then
		rltext:ActiveSettings().disabled = not(rltext:ActiveSettings().disabled)
		return
	end
	if args == "readycheck" then
		--readycheck.StartListening()
		rltext.module.List['ReadyCheck'].StartListening()
		return
	end
	if args == "pr" then
		if rltext.bIsPositioning then return end

		rltext.bIsPreview = not(rltext.bIsPreview)
		if rltext.bIsPreview then
			rltext.Preview()
		else
			rltext.stopPreviews()
		end
	end
	if args == "rp" then
		rltext.ToggleRaidPlanner()
	end
end


local function _isActualMessage(txt, check)
	local checkfor = string.sub(txt,1,string.len(check))
	if checkfor == check then return false end
	return true
end

local function isActualMessage(msg, tbl)
	for _,v in pairs(tbl) do
		if not(_isActualMessage(msg, v)) then
			return false
		end
	end
	return true
end


function rltext.OnChat(eventcode, messageType, messageFrom, messageText)
	if rltext:ActiveSettings().disabled then return end
	if rltext.bIsPreview then return end --we don't want new messages to appear in the preview do we?
	if not rltext.masterList then return end

	if messageType == 3 then
		messageFrom = zo_strformat("<<t:1>>", messageFrom)
		local aName = messageFrom

		--fixes a super rare occourence
		--local playerTag = rltext.SuperListGroup(aName)

		--aName = playerTag.name
		--messageFrom = playerTag.name

		if not(rltext.masterList[aName]) then return end

		local newLeader = GetGroupLeaderUnitTag()
		local leadName = GetUnitName(newLeader)

		--leadName = zo_strformat("<<t:1>>", leadName)

		--don't need these to show ^_^
		if not(isActualMessage(messageText, {"FTC","[FTC]","MM", "M.M"})) then
			return
		end

		messageText = string.gsub(messageText, "||c", "|c")
		messageText = string.gsub(messageText, "||r", "|r")

		if aName == leadName then
			if string.len(messageText) > 9 then
				local rltez = string.sub(messageText,1,string.len("<RLEZ: "))
				if rltez == "<RLEZ: " then
					rltext.ReceivedSec(messageText)
				else
					rltext.Draw(messageFrom, messageText, 1)
				end
			else

				rltext.Draw(messageFrom, messageText, 1)

			end
		else
			if rltext.masterList[aName].issec then
				local rltez = string.sub(messageText,1,string.len("#invite "))
				local rltezk = string.sub(messageText,1,string.len("#kick "))
				if rltez == "#invite " then
					if rltext.player == leadName then
						rltext.ReceivedInvite(messageText)
					end
				elseif rltezk == "#kick " then
					if rltext.player == leadName then
						rltext.ReceivedKick(messageFrom, messageText)
					end
				else
					rltext.Draw(messageFrom, messageText, 3)
				end
			else
				if not(rltext.masterList[aName].cantalk) then return end
				rltext.Draw(messageFrom, messageText, 2)
			end
		end

	end
end


EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_ADD_ON_LOADED, OnAddOnLoaded)
EVENT_MANAGER:RegisterForEvent(rltext.name.."txt", EVENT_CHAT_MESSAGE_CHANNEL, rltext.OnChat)


function rltext.SuperListGroup(fullName)
	local pOut = {}

	for i=1,GetGroupSize() do
		local tag = GetGroupUnitTagByIndex(i)
		local n = GetUnitName(tag)
		if n == fullName then
			table.insert(pOut, {name=n,ttg=tag})
		end
	end

	if #pOut <= 0 then
		return {name="",ttg=nil}
	end

	if #pOut == 1 then
		return pOut[1]
	end
end

function rltext.ListGroup(partialName)
	local pOut = {}

	for i=1,GetGroupSize() do
		local tag = GetGroupUnitTagByIndex(i)
		local n = GetUnitName(tag)
		if string.find( string.lower(n), string.lower(partialName) ) then
			table.insert(pOut, {name=n,ttg=tag})
		end
	end

	if #pOut <= 0 then
		msg("RLE: Nobody with the name \""..partialName.."\" in the group.")
		return false
	end

	if #pOut > 1 then
		local _pOut = {}
		--Multiple names contain partialName.. let's see if we can fix that
		for k,v in ipairs(pOut) do
			if string.len(v.name) == string.len(partialName) then
				table.insert(_pOut, {name=v.name,ttg=v.ttg})
			end
		end

		if #_pOut <= 0 then
			return false
		end

		if #_pOut > 1 then
			return false
		end

		if #_pOut == 1 then
			return _pOut[1]
		end
	end

	if #pOut == 1 then
		return pOut[1]
	end
end

function rltext.ReceivedInvite(text)
	if rltext:ActiveSettings().disabledinv then return end

	text = string.sub(text,string.len("#invite ")+1,string.len(text))

	--GroupInviteByName(text)
	SLASH_COMMANDS["/invite"](text)
end

function rltext.ReceivedKick(from, text)
	if rltext:ActiveSettings().disabledkik then return end

	text = string.sub(text,string.len("#kick ")+1,string.len(text))

	local playerTag = rltext.ListGroup(text)

	if playerTag then
		--sec leader can't kick another sec leader
		if rltext.masterList[playerTag.name].issec then return end

		local newLeader = GetGroupLeaderUnitTag()
		local leadName = GetUnitName(newLeader)
		--leadName = zo_strformat("<<t:1>>", leadName)

		--sec leader can't kick leader
		if playerTag.name == leadName then return end

		--can't kick himself
		if playerTag.name == from then return end

		if playerTag then
			GroupKick(playerTag.ttg)
			return
		end
	end
end


function rltext.ReceivedSec(text)
	text = string.sub(text,string.len("<RLEZ: ")+1,string.len(text))
	local ntext = rltext.strsplit(text, ",")

	if #ntext < 1 then return end

	ntext[#ntext] = string.sub(ntext[#ntext],1,string.len(ntext[#ntext])-1)

	if string.len(ntext[1]) < 4 then return end

	--reset sec
	for k,v in pairs(rltext.masterList) do
		if v.issec then
			rltext.masterList[k].issec = false
		end
	end

	--and set them again
	if not(ntext[1] == "#None") then

		local ll = ""
		for _k,_v in ipairs(ntext) do
			if rltext.masterList[_v] then
				rltext.masterList[_v].issec = true

				if _k == 1 then
					ll = ll.._v
				else
					if _k == #ntext then
						ll = ll.." and ".._v
					else
						ll = ll..", ".._v
					end
				end

			end
		end

		if #ntext > 1 then
			d("RLE: "..ll.." are now secondary leaders.")
		else
			d("RLE: "..ll.." is now secondary leader.")
		end

	end

	rltext.UpdateList()

end


function rltext.PrintSec()
	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)
	if not(rltext.player == leadName) then return end

	local secText = "<RLEZ: "

	local n = 0
	for k,v in pairs(rltext.masterList) do
		if v.issec then
			if n > 0 then
				secText = secText..","..k
			else
				secText = secText..k
			end
			n = n+1
		end
	end

	if n == 0 then
		secText = secText.."#None"
	end

	secText = secText..">"
	local ChatEditControl = CHAT_SYSTEM.textEntry.editControl
	ChatEditControl:InsertText(secText)
end
