

rltext.SelectedControl = nil
rltext.ControlData = {}

function rltext:OnWindowMoveStop(control)
	rltext:ActiveSettings().gwinLeft = RLGroupControlWindow:GetLeft()
	rltext:ActiveSettings().gwinTop = RLGroupControlWindow:GetTop()
end

function rltext.MainIsClicked(control, button)
	if not rltext.SelectedControl then return end

	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

	local data = rltext.SelectedControl:GetParent().data
	if data then
		if data.player == leadName then return end
		rltext.masterList[data.player].cantalk = not(rltext.masterList[data.player].cantalk)
	end

	rltext.scrollList:RefreshData()
end

function rltext.SecIsClicked(control, button)
	if not rltext.SelectedControl then return end

	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

	if not(rltext.player == leadName) then return end --normal group members can't change sec

	local data = rltext.SelectedControl:GetParent().data
	if data then
		if data.player == leadName then return end
		rltext.masterList[data.player].issec = not(rltext.masterList[data.player].issec)
		if not(rltext.masterList[data.player].issec) and rltext:ActiveSettings().savesec then
			local toRemovek = 0
			for k,v in ipairs(rltext:ActiveSettings().savedSec) do
				if v == data.player then
					toRemovek = k
					break
				end
			end
			if toRemovek > 0 then
				table.remove(rltext:ActiveSettings().savedSec, toRemovek)
			end
		end
		rltext.saveSecondary()
	end

	rltext.scrollList:RefreshData()
end

function rltext.ScrollMouseEnter(control)
	rltext.scrollList:Row_OnMouseEnter(control)
	rltext.SelectedControl = control
end
function rltext.ScrollMouseExit(control)
	rltext.scrollList:Row_OnMouseExit(control)
	rltext.SelectedControl = nil
end

function rltext.ScrollMounseEnterTT(control)
	local parent = rltext.SelectedControl:GetParent()

	if not(rltext.ControlData[parent:GetName()]) then return end

	local data = rltext.ControlData[parent:GetName()]

	local name = data.player

	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

	if name == leadName then return end

	rltext:HeaderToolTip(rltext.SelectedControl:GetParent(), "Show Text")
end

function rltext.ScrollMounseEnterTTT(control)
	local parent = rltext.SelectedControl:GetParent()

	if not(rltext.ControlData[parent:GetName()]) then return end

	local data = rltext.ControlData[parent:GetName()]

	local name = data.player

	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

	if name == leadName then return end

	if rltext.masterList[name] then
		if rltext.player == leadName then
			if not(rltext.masterList[name].issec) then
				rltext:HeaderToolTip(parent, "Set Secondary Lead")
			else
				rltext:HeaderToolTip(parent, "Remove Secondary Lead")
			end
		else
			if rltext.masterList[name].issec then
				rltext:HeaderToolTip(parent, "Secondary Lead")
			end
		end
	end
	
end

function rltext:HeaderToolTip(control, tipString)
	InitializeTooltip(InformationTooltip, control, TOPRIGHT, 0, 5, BOTTOMRIGHT)
	SetTooltipText(InformationTooltip, tipString)
end

function rltext.ToggleWindow()
	if rltext:ActiveSettings().alon then
		RLGroupControlWindow:SetHidden(false)
		return
	end
	RLGroupControlWindow:SetHidden(not RLGroupControlWindow:IsHidden())
end

rltext.SecButton = nil

function rltext:WinInit()
	RLGroupControlWindow:ClearAnchors()
	RLGroupControlWindow:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, rltext:ActiveSettings().gwinLeft, rltext:ActiveSettings().gwinTop)

	rltext:ChangeSize()

	rltext.scrollList = rlscrollList:New(RLGroupControlWindow)

	if not(rltext.SecButton) then

		rltext.SecButton = rltext.wm:CreateControl("SecButton", RLGroupControlWindow, CT_BUTTON);
		rltext.SecButton:SetDimensions(32, 32);
		rltext.SecButton:SetAnchor(TOPLEFT, RLGroupControlWindow, TOPLEFT, 10, 0);

		rltext.SecButton:SetHandler("OnClicked", function(self) rltext.PrintSec() end)
		rltext.SecButton:SetHandler("OnMouseEnter", function(self) rltext:HeaderToolTip(self, "Send Secondary Lead Info")end)
		rltext.SecButton:SetHandler("OnMouseExit", function(self) ClearTooltip(InformationTooltip) end)

		rltext.SecButton:SetPressedTexture("/esoui/art/buttons/plus_down.dds")
		rltext.SecButton:SetNormalTexture("/esoui/art/buttons/plus_up.dds")
		rltext.SecButton:SetMouseOverTexture("/esoui/art/buttons/plus_over.dds")
	end

end

function rltext:ChangeSize()
	local sx = rltext:ActiveSettings().gwinSizeX
	local sy = rltext:ActiveSettings().gwinSizeY
	local al = rltext:ActiveSettings().gwinAlpha

	RLGroupControlWindow:SetDimensions(sx,sy)

	RLGroupControlWindowBG:SetAnchorFill(RLGroupControlWindow)
	RLGroupControlWindowBG:SetCenterColor(0, 0, 0, 1)
	RLGroupControlWindowBG:SetEdgeColor(0, 0, 0, 1)
	RLGroupControlWindowBG:SetEdgeTexture('', 8, 8, 1, 0)
	RLGroupControlWindowBG:SetInsets(0,0,0,0)

	RLGroupControlWindowBG:SetAlpha((al/100))


end

rltext._StatusList = {}
rltext.scrollList = nil
rlscrollList = ZO_SortFilterList:Subclass()
rlscrollList.defaults = {}

local CheckBoxIcon = "RaidLeadEssentials/icons/box.dds"
local CheckBoxIconChecked = "RaidLeadEssentials/icons/box_checked.dds"

function rlscrollList:SetupSalesRow(control, data)
	control.data = data

	rltext.ControlData[control:GetName()] = data

	control.name = GetControl(control, 'Player')
	control.cantalk = GetControl(control, 'Cantalk')
	control.issec = GetControl(control, 'Issec')

	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

	local isLeader = (leadName == data.player)
	local isLocalLead = (leadName == rltext.player)

	if isLeader then
		control.name:SetText("|t32:32:/esoui/art/lfg/lfg_leader_icon.dds|t|c999999"..tostring(data.player).."|r")
		if data.player == "Mizuki Andariaa" then
			control.name:SetText("|t32:32:/esoui/art/lfg/lfg_leader_icon.dds|t|c970590"..tostring(data.player).."|r")
		end
	elseif data.issec then
		control.name:SetText("|t32:32:ESOUI/art/guild/guild_indexicon_officer_down.dds|t"..tostring(data.player))
		if data.player == "Mizuki Andariaa" then
			control.name:SetText("|t32:32:ESOUI/art/guild/guild_indexicon_officer_down.dds|t|cfd4bf4"..tostring(data.player))
		end
	else
		control.name:SetText("|t32:32:RaidLeadEssentials/icons/missing.dds|t"..tostring(data.player))
		if data.player == "Mizuki Andariaa" then
			control.name:SetText("|t32:32:RaidLeadEssentials/icons/missing.dds|t|cfd4bf4"..tostring(data.player))
		end
	end

	if data.cantalk then
		control.cantalk:SetText("|t16:16:"..CheckBoxIconChecked.."|t")
	else
		control.cantalk:SetText("|t16:16:"..CheckBoxIcon.."|t")
	end

	--leaders can always talk
	if isLeader then
		control.cantalk:SetText("")
	end

	if isLocalLead then
		if data.issec then
			control.issec:SetText("|t16:16:"..CheckBoxIconChecked.."|t")
		else
			control.issec:SetText("|t16:16:"..CheckBoxIcon.."|t")
		end
		if isLeader then
			control.issec:SetText("")
		end
	else
		if data.issec then
			control.issec:SetText("|t16:16:esoui/art/cadwell/check.dds|t")
		else
			control.issec:SetText("")
		end
	end

	ZO_SortFilterList.SetupRow(self, control, data)
end

function rlscrollList:ColorRow(control, data, mouseIsOver)
end

function rlscrollList:InitializeDataType(controlName)
	self.masterList = {}

	ZO_ScrollList_AddDataType(self.list, 1, 'ControlWindowRow', 20, function(control, data) self:SetupSalesRow(control, data) end)

	self:RefreshData()
end

function rlscrollList:New(control)
	local skList = ZO_SortFilterList.New(self, control)
	skList:InitializeDataType(control:GetName())

	return skList
end

function rlscrollList:BuildMasterList()
	self.masterList = {}
	if rltext.masterList then
		local units = rltext.masterList
		local data = {}

		for k, v in pairs(units) do
			local a = v.cantalk
			local b = v.issec
			data = {player=k, cantalk=a, issec=b}
			table.insert(self.masterList, data)
		end
	end
end

function rlscrollList:FilterScrollList()
	local scrollData = ZO_ScrollList_GetDataList(self.list)
	ZO_ClearNumericallyIndexedTable(scrollData)

	for k, v in pairs(self.masterList) do
		local data = v
		table.insert(scrollData, ZO_ScrollList_CreateDataEntry(1, data))
	end
end

function rlscrollList:SortScrollList()
end


-- Extra function buttons
function rltext.OnReadyCheckButton()
	rltext.module.List[1].StartListening()
end


-- Raidplanner
function rltext.ToggleRaidPlanner()
	RLPlannerWindow:SetHidden(not(RLPlannerWindow:IsHidden()))
	if RLPlannerWindow:IsHidden() then
		RLNewRaidWindow:SetHidden(true)
		RLPlannerWindow:SetAlpha(1)
	end
end

function rltext:OnWindowMoveStopPlanner(self)
	rltext.module:GetModuleVars("RaidPlanner").winx = RLPlannerWindow:GetLeft()
	rltext.module:GetModuleVars("RaidPlanner").winy = RLPlannerWindow:GetTop()
end