
local raidplanner = rltext.module:New()
raidplanner.name = "RaidPlanner"
raidplanner.isActive = false
raidplanner.activeRaid = {}
raidplanner.scrollList = nil
raidplanner.SelectedControl = nil
raidplanner.id = 3

function raidplanner:Init()
	local newVars = {}

	local screenWidth, screenHeight = GuiRoot:GetDimensions()
	table.insert(newVars, {
		name = "raids",
		value = {},
	})
	table.insert(newVars, {
		name = "winx",
		value = (screenWidth/2),
	})
	table.insert(newVars, {
		name = "winy",
		value = (screenHeight/2),
	})

	rltext.module:AddSavedVars(raidplanner.name, newVars)

	local nButton = {}
	nButton.OnEnter = function(self) end
	nButton.OnLeave = function(self) end
	nButton.OnClicked = function(self) rltext.ToggleRaidPlanner() end
	nButton.toolTip = "Open RaidPlanner"

	local rButton = rltext.module:AddButton(raidplanner.name, nButton)
	rButton:SetPressedTexture("/esoui/art/buttons/edit_save_down.dds")
	rButton:SetNormalTexture("/esoui/art/buttons/edit_save_up.dds")
	rButton:SetMouseOverTexture("/esoui/art/buttons/edit_save_over.dds")

	RLPlannerWindow:ClearAnchors()
	RLPlannerWindow:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, rltext.module:GetModuleVars(raidplanner.name).winx, rltext.module:GetModuleVars(raidplanner.name).winy)
	RLPlannerWindow:SetDimensions(800,500)
	RLPlannerWindow_BG:SetAnchorFill(RLPlannerWindow)
	RLPlannerWindow_BG:SetCenterColor(0, 0, 0, .7)
	RLPlannerWindow_BG:SetEdgeColor(214/255, 197/255, 144/255, .7)
	RLPlannerWindow_BG:SetEdgeTexture('', 8, 8, 1, 0)
	RLPlannerWindow_BG:SetInsets(0,0,0,0)
	RLPlannerWindow_BG:SetAlpha(100)
	RLPlannerWindow:SetClampedToScreen(true)

	--RLPlannerWindow_div1:SetAnchorFill(RLPlannerWindow)
	RLPlannerWindow_div1:SetDimensions(798,2)
	RLPlannerWindow_div1:SetColor(214/255, 197/255, 144/255, .7)
	RLPlannerWindow_div1:SetAlpha(100)

	RLPlannerWindow_div2:SetDimensions(798,2)
	RLPlannerWindow_div2:SetColor(214/255, 197/255, 144/255, .7)
	RLPlannerWindow_div2:SetAlpha(100)

	RLPlannerWindow_Close:SetPressedTexture("/esoui/art/buttons/cancel_down.dds")
	RLPlannerWindow_Close:SetNormalTexture("/esoui/art/buttons/cancel_up.dds")
	RLPlannerWindow_Close:SetMouseOverTexture("/esoui/art/buttons/cancel_over.dds")

	RLPlannerWindow_ButtonNew:SetPressedTexture("/esoui/art/buttons/edit_save_down.dds")
	RLPlannerWindow_ButtonNew:SetNormalTexture("/esoui/art/buttons/edit_save_up.dds")
	RLPlannerWindow_ButtonNew:SetMouseOverTexture("/esoui/art/buttons/edit_save_over.dds")

	RLPlannerWindow_ButtonLoad:SetPressedTexture("/esoui/art/buttons/edit_save_down.dds")
	RLPlannerWindow_ButtonLoad:SetNormalTexture("/esoui/art/buttons/edit_save_up.dds")
	RLPlannerWindow_ButtonLoad:SetMouseOverTexture("/esoui/art/buttons/edit_save_over.dds")

	RLPlannerWindow_ButtonDelete:SetPressedTexture("/esoui/art/buttons/edit_save_down.dds")
	RLPlannerWindow_ButtonDelete:SetNormalTexture("/esoui/art/buttons/edit_save_up.dds")
	RLPlannerWindow_ButtonDelete:SetMouseOverTexture("/esoui/art/buttons/edit_save_over.dds")

	RLPlannerWindow_StatusBot:SetHorizontalAlignment(TEXT_ALIGN_LEFT)

	local nps = 1
	for i=1,12,1 do
		local RLPlannerWindow_Combo1 = CreateControlFromVirtual('ComboBox'..tostring(i), RLPlannerWindow, 'RLVirtCombo')
		RLPlannerWindow_Combo1:SetDimensions(150,25)

		if i == 7 then
			nps = 1
		end

		local xps = 160
		local yps = (50*(nps-1))
		nps = nps+1

		if i > 6 then
			xps = 575
		end

		RLPlannerWindow_Combo1:SetAnchor(TOPLEFT, RLPlannerWindow_Edit1, TOPLEFT, xps, yps)
		RLPlannerWindow_Combo1.m_comboBox:SetSortsItems(false)

		local combo1 = ZO_ComboBox_ObjectFromContainer(RLPlannerWindow_Combo1)
		combo1:ClearItems()
		local timeEntry = combo1:CreateItemEntry("Tank", function() raidplanner:SetRole(i, 1) end)
		combo1:AddItem(timeEntry)
		timeEntry = combo1:CreateItemEntry("DPS", function() raidplanner:SetRole(i, 2) end)
		combo1:AddItem(timeEntry)
		timeEntry = combo1:CreateItemEntry("Heal", function() raidplanner:SetRole(i, 3) end)
		combo1:AddItem(timeEntry)
		combo1:SetSelectedItem("Tank")
	end

	----------------------------
	RLNewRaidWindow_Close:SetPressedTexture("/esoui/art/buttons/cancel_down.dds")
	RLNewRaidWindow_Close:SetNormalTexture("/esoui/art/buttons/cancel_up.dds")
	RLNewRaidWindow_Close:SetMouseOverTexture("/esoui/art/buttons/cancel_over.dds")

	RLLoadRaidWindow_Close:SetPressedTexture("/esoui/art/buttons/cancel_down.dds")
	RLLoadRaidWindow_Close:SetNormalTexture("/esoui/art/buttons/cancel_up.dds")
	RLLoadRaidWindow_Close:SetMouseOverTexture("/esoui/art/buttons/cancel_over.dds")


	local confirmDialog = {
		title = { text = "Confirmation" },
		mainText = { text = "A Raid with the same name already exists! Overwrite?" },
		buttons = {{
			text = "Yes!",
			callback = function(dialog) raidplanner:ActualDone(dialog.data.ctrl) end
		},{ text = "No!" }}
		}
	ZO_Dialogs_RegisterCustomDialog("confirmDial2", confirmDialog)



	confirmDialog = {
		title = { text = "Confirmation" },
		mainText = { text = "Are you sure you want to delete this Raid?" },
		buttons = {{
			text = "Yes!",
			callback = function()

				raidplanner:HalfShow()

				raidplanner:GetVars().raids[raidplanner.activeRaid.name] = nil

				RLPlannerWindow_StatusBot:SetText("0 TANK / 0 DPS / 0 HEAL")
				RLPlannerWindow_LoadedText:SetText("")

				raidplanner.activeRaid = {}

				RLPlannerWindow_Status:SetText("No Raid is currently loaded.")


				RLPlannerWindow_Edit1:SetText("")
				RLPlannerWindow_Edit2:SetText("")
				RLPlannerWindow_Edit3:SetText("")
				RLPlannerWindow_Edit4:SetText("")
				RLPlannerWindow_Edit5:SetText("")
				RLPlannerWindow_Edit6:SetText("")
				RLPlannerWindow_Edit7:SetText("")
				RLPlannerWindow_Edit8:SetText("")
				RLPlannerWindow_Edit9:SetText("")
				RLPlannerWindow_Edit10:SetText("")
				RLPlannerWindow_Edit11:SetText("")
				RLPlannerWindow_Edit12:SetText("")

				ZO_ComboBox_ObjectFromContainer(ComboBox1):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox2):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox3):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox4):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox5):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox6):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox7):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox8):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox9):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox10):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox11):SetSelectedItem("Tank")
				ZO_ComboBox_ObjectFromContainer(ComboBox12):SetSelectedItem("Tank")

				RLPlannerWindow_Edit1:SetHidden(true)
				RLPlannerWindow_Edit2:SetHidden(true)
				RLPlannerWindow_Edit3:SetHidden(true)
				RLPlannerWindow_Edit4:SetHidden(true)
				RLPlannerWindow_Edit5:SetHidden(true)
				RLPlannerWindow_Edit6:SetHidden(true)
				RLPlannerWindow_Edit7:SetHidden(true)
				RLPlannerWindow_Edit8:SetHidden(true)
				RLPlannerWindow_Edit9:SetHidden(true)
				RLPlannerWindow_Edit10:SetHidden(true)
				RLPlannerWindow_Edit11:SetHidden(true)
				RLPlannerWindow_Edit12:SetHidden(true)
				ComboBox1:SetHidden(true)
				ComboBox2:SetHidden(true)
				ComboBox3:SetHidden(true)
				ComboBox4:SetHidden(true)
				ComboBox5:SetHidden(true)
				ComboBox6:SetHidden(true)
				ComboBox7:SetHidden(true)
				ComboBox8:SetHidden(true)
				ComboBox9:SetHidden(true)
				ComboBox10:SetHidden(true)
				ComboBox11:SetHidden(true)
				ComboBox12:SetHidden(true)
		end
		},{ text = "No!" }}
	}
	ZO_Dialogs_RegisterCustomDialog("confirmDial", confirmDialog)
end

function raidplanner:Options()
	local optionsData = {}

	rltext.module:AddOptions(raidplanner.name, optionsData)
end

function raidplanner:GetVars()
	return rltext.module:GetModuleVars(raidplanner.name)
end

function raidplanner:SetRole(num, role)
	raidplanner.activeRaid.members[num].role = role

	raidplanner:Save()
end

function raidplanner:HalfShow()
	RLNewRaidWindow:SetHidden(true)
	RLLoadRaidWindow:SetHidden(true)
	RLPlannerWindow:SetAlpha(1)

end

function raidplanner:OnNew()
	raidplanner:HalfShow()

	RLNewRaidWindow:SetHidden(false)
	RLPlannerWindow:SetAlpha(0.5)

end

function raidplanner:ActualDone(control)
	raidplanner:HalfShow()
	RLPlannerWindow_LoadedText:SetText(control:GetText())
	RLPlannerWindow_Status:SetText("")

	RLPlannerWindow_Edit1:SetText("")
	RLPlannerWindow_Edit2:SetText("")
	RLPlannerWindow_Edit3:SetText("")
	RLPlannerWindow_Edit4:SetText("")
	RLPlannerWindow_Edit5:SetText("")
	RLPlannerWindow_Edit6:SetText("")
	RLPlannerWindow_Edit7:SetText("")
	RLPlannerWindow_Edit8:SetText("")
	RLPlannerWindow_Edit9:SetText("")
	RLPlannerWindow_Edit10:SetText("")
	RLPlannerWindow_Edit11:SetText("")
	RLPlannerWindow_Edit12:SetText("")

	ZO_ComboBox_ObjectFromContainer(ComboBox1):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox2):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox3):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox4):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox5):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox6):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox7):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox8):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox9):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox10):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox11):SetSelectedItem("Tank")
	ZO_ComboBox_ObjectFromContainer(ComboBox12):SetSelectedItem("Tank")

	RLPlannerWindow_Edit1:SetHidden(false)
	RLPlannerWindow_Edit2:SetHidden(false)
	RLPlannerWindow_Edit3:SetHidden(false)
	RLPlannerWindow_Edit4:SetHidden(false)
	RLPlannerWindow_Edit5:SetHidden(false)
	RLPlannerWindow_Edit6:SetHidden(false)
	RLPlannerWindow_Edit7:SetHidden(false)
	RLPlannerWindow_Edit8:SetHidden(false)
	RLPlannerWindow_Edit9:SetHidden(false)
	RLPlannerWindow_Edit10:SetHidden(false)
	RLPlannerWindow_Edit11:SetHidden(false)
	RLPlannerWindow_Edit12:SetHidden(false)
	ComboBox1:SetHidden(false)
	ComboBox2:SetHidden(false)
	ComboBox3:SetHidden(false)
	ComboBox4:SetHidden(false)
	ComboBox5:SetHidden(false)
	ComboBox6:SetHidden(false)
	ComboBox7:SetHidden(false)
	ComboBox8:SetHidden(false)
	ComboBox9:SetHidden(false)
	ComboBox10:SetHidden(false)
	ComboBox11:SetHidden(false)
	ComboBox12:SetHidden(false)

	raidplanner.activeRaid = {
								["name"] = control:GetText(),
								["members"] = {
									[1]={["name"]="",["role"]=1},
									[2]={["name"]="",["role"]=1},
									[3]={["name"]="",["role"]=1},
									[4]={["name"]="",["role"]=1},
									[5]={["name"]="",["role"]=1},
									[6]={["name"]="",["role"]=1},
									[7]={["name"]="",["role"]=1},
									[8]={["name"]="",["role"]=1},
									[9]={["name"]="",["role"]=1},
									[10]={["name"]="",["role"]=1},
									[11]={["name"]="",["role"]=1},
									[12]={["name"]="",["role"]=1},
								},
							}

	control:SetText("")

	RLPlannerWindow_StatusBot:SetText("12 TANK / 0 DPS / 0 HEAL")
	raidplanner:Save()
	raidplanner:OnLoadDone(raidplanner.activeRaid.name)
end

function raidplanner:OnNewDone(control)

	if raidplanner:GetVars().raids[control:GetText()] then
		ZO_Dialogs_ShowDialog("confirmDial2", {["ctrl"] = control}, nil)
	else
		raidplanner:ActualDone(control)
	end
end

function raidplanner:OnCancel()
	raidplanner:HalfShow()
end

function raidplanner:OnLoad()
	raidplanner:HalfShow()

	if not(raidplanner.scrollList) then
		raidplanner.scrollList = rpscrollList:New(RLLoadRaidWindow)
	end

	raidplanner.scrollList:RefreshData()

	RLLoadRaidWindow:SetHidden(false)
	RLPlannerWindow:SetAlpha(0.5)
end

function raidplanner:GetSelectRole(role)
	if role == 1 then return "Tank" end
	if role == 2 then return "DPS" end
	if role == 3 then return "Heal" end
end

function raidplanner:OnLoadDone(selection, isControl)
	raidplanner:HalfShow()

	if isControl then
		selection = raidplanner.SelectedControl.data.name
	end

	local toLoad = raidplanner:GetVars().raids[selection]

	RLPlannerWindow_Status:SetText("")

	RLPlannerWindow_Edit1:SetText(toLoad[1].name)
	RLPlannerWindow_Edit2:SetText(toLoad[2].name)
	RLPlannerWindow_Edit3:SetText(toLoad[3].name)
	RLPlannerWindow_Edit4:SetText(toLoad[4].name)
	RLPlannerWindow_Edit5:SetText(toLoad[5].name)
	RLPlannerWindow_Edit6:SetText(toLoad[6].name)
	RLPlannerWindow_Edit7:SetText(toLoad[7].name)
	RLPlannerWindow_Edit8:SetText(toLoad[8].name)
	RLPlannerWindow_Edit9:SetText(toLoad[9].name)
	RLPlannerWindow_Edit10:SetText(toLoad[10].name)
	RLPlannerWindow_Edit11:SetText(toLoad[11].name)
	RLPlannerWindow_Edit12:SetText(toLoad[12].name)

	ZO_ComboBox_ObjectFromContainer(ComboBox1):SetSelectedItem(raidplanner:GetSelectRole(toLoad[1].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox2):SetSelectedItem(raidplanner:GetSelectRole(toLoad[2].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox3):SetSelectedItem(raidplanner:GetSelectRole(toLoad[3].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox4):SetSelectedItem(raidplanner:GetSelectRole(toLoad[4].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox5):SetSelectedItem(raidplanner:GetSelectRole(toLoad[5].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox6):SetSelectedItem(raidplanner:GetSelectRole(toLoad[6].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox7):SetSelectedItem(raidplanner:GetSelectRole(toLoad[7].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox8):SetSelectedItem(raidplanner:GetSelectRole(toLoad[8].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox9):SetSelectedItem(raidplanner:GetSelectRole(toLoad[9].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox10):SetSelectedItem(raidplanner:GetSelectRole(toLoad[10].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox11):SetSelectedItem(raidplanner:GetSelectRole(toLoad[11].role))
	ZO_ComboBox_ObjectFromContainer(ComboBox12):SetSelectedItem(raidplanner:GetSelectRole(toLoad[12].role))

	RLPlannerWindow_Edit1:SetHidden(false)
	RLPlannerWindow_Edit2:SetHidden(false)
	RLPlannerWindow_Edit3:SetHidden(false)
	RLPlannerWindow_Edit4:SetHidden(false)
	RLPlannerWindow_Edit5:SetHidden(false)
	RLPlannerWindow_Edit6:SetHidden(false)
	RLPlannerWindow_Edit7:SetHidden(false)
	RLPlannerWindow_Edit8:SetHidden(false)
	RLPlannerWindow_Edit9:SetHidden(false)
	RLPlannerWindow_Edit10:SetHidden(false)
	RLPlannerWindow_Edit11:SetHidden(false)
	RLPlannerWindow_Edit12:SetHidden(false)
	ComboBox1:SetHidden(false)
	ComboBox2:SetHidden(false)
	ComboBox3:SetHidden(false)
	ComboBox4:SetHidden(false)
	ComboBox5:SetHidden(false)
	ComboBox6:SetHidden(false)
	ComboBox7:SetHidden(false)
	ComboBox8:SetHidden(false)
	ComboBox9:SetHidden(false)
	ComboBox10:SetHidden(false)
	ComboBox11:SetHidden(false)
	ComboBox12:SetHidden(false)


	raidplanner.activeRaid = {
								["name"]= selection,
								["members"] = {
									[1]={["name"]=toLoad[1].name,["role"]=toLoad[1].role},
									[2]={["name"]=toLoad[2].name,["role"]=toLoad[2].role},
									[3]={["name"]=toLoad[3].name,["role"]=toLoad[3].role},
									[4]={["name"]=toLoad[4].name,["role"]=toLoad[4].role},
									[5]={["name"]=toLoad[5].name,["role"]=toLoad[5].role},
									[6]={["name"]=toLoad[6].name,["role"]=toLoad[6].role},
									[7]={["name"]=toLoad[7].name,["role"]=toLoad[7].role},
									[8]={["name"]=toLoad[8].name,["role"]=toLoad[8].role},
									[9]={["name"]=toLoad[9].name,["role"]=toLoad[9].role},
									[10]={["name"]=toLoad[10].name,["role"]=toLoad[10].role},
									[11]={["name"]=toLoad[11].name,["role"]=toLoad[11].role},
									[12]={["name"]=toLoad[12].name,["role"]=toLoad[12].role},
								},
							}

	RLPlannerWindow_LoadedText:SetText(selection)

	RLLoadRaidWindowInfo:SetText("No Selection")

	raidplanner:Save(true)

end

function raidplanner:OnDelete()
	if raidplanner.activeRaid.name then
		ZO_Dialogs_ShowDialog("confirmDial", nil, nil)
	end
end

function raidplanner:Save(doNoSave)

	if not(doNoSave) then
		raidplanner:GetVars().raids[raidplanner.activeRaid.name] = {
			[1]	= {["name"] = RLPlannerWindow_Edit1:GetText(), ["role"] = raidplanner.activeRaid.members[1].role},
			[2]	= {["name"] = RLPlannerWindow_Edit2:GetText(), ["role"] = raidplanner.activeRaid.members[2].role},
			[3]	= {["name"] = RLPlannerWindow_Edit3:GetText(), ["role"] = raidplanner.activeRaid.members[3].role},
			[4]	= {["name"] = RLPlannerWindow_Edit4:GetText(), ["role"] = raidplanner.activeRaid.members[4].role},
			[5]	= {["name"] = RLPlannerWindow_Edit5:GetText(), ["role"] = raidplanner.activeRaid.members[5].role},
			[6]	= {["name"] = RLPlannerWindow_Edit6:GetText(), ["role"] = raidplanner.activeRaid.members[6].role},
			[7]	= {["name"] = RLPlannerWindow_Edit7:GetText(), ["role"] = raidplanner.activeRaid.members[7].role},
			[8]	= {["name"] = RLPlannerWindow_Edit8:GetText(), ["role"] = raidplanner.activeRaid.members[8].role},
			[9]	= {["name"] = RLPlannerWindow_Edit9:GetText(), ["role"] = raidplanner.activeRaid.members[9].role},
			[10]	= {["name"] = RLPlannerWindow_Edit10:GetText(), ["role"] = raidplanner.activeRaid.members[10].role},
			[11]	= {["name"] = RLPlannerWindow_Edit11:GetText(), ["role"] = raidplanner.activeRaid.members[11].role},
			[12]	= {["name"] = RLPlannerWindow_Edit12:GetText(), ["role"] = raidplanner.activeRaid.members[12].role},
		}
	end

	--because we save like.. always we can update the role text
	local ntank = 0
	local ndps = 0
	local nheal = 0

	for k,v in ipairs(raidplanner.activeRaid.members) do
		if v.role == 1 then
			ntank = ntank+1
		elseif v.role == 2 then
			ndps = ndps+1
		elseif v.role == 3 then
			nheal = nheal+1
		end
	end
	RLPlannerWindow_StatusBot:SetText(tostring(ntank).." TANK / "..tostring(ndps).." DPS / "..tostring(nheal).." HEAL")

end


raidplanner.scrollList = nil
rpscrollList = ZO_SortFilterList:Subclass()
rpscrollList.defaults = {}
-- Sort keys for the scroll lists
rpscrollList.SORT_KEYS = {
		['name'] = {isNumeric = false},
	}


local CheckBoxIcon = "RaidLeadEssentials/icons/box.dds"
local CheckBoxIconChecked = "RaidLeadEssentials/icons/box_checked.dds"

function rpscrollList:SetupSalesRow(control, data)
	control.data = data
	control.name = GetControl(control, 'Name')

	control.name:SetText(tostring(data.name))

	ZO_SortFilterList.SetupRow(self, control, data)
end

function rpscrollList:ColorRow(control, data, mouseIsOver)
	for i = 1, control:GetNumChildren() do
		local child = control:GetChild(i)
		if not child.nonRecolorable then
			if child:GetType() == CT_LABEL then
				if string.find(child:GetName(), 'Price$') then child:SetColor(0.84, 0.71, 0.15, 1)
				else child:SetColor(1, 1, 1, 1) end
			end
		end
	end
end

function rpscrollList:InitializeDataType(controlName)
	self.masterList = {}

	ZO_ScrollList_AddDataType(self.list, 1, 'RaidLoadRow', 32, function(control, data) self:SetupSalesRow(control, data) end)

	ZO_ScrollList_EnableHighlight(self.list, "ZO_TallListHighlight")

	self:RefreshData()
end

function rpscrollList:New(control)
	local skList = ZO_SortFilterList.New(self, control)
	skList:InitializeDataType(control:GetName())

	return skList
end

function rpscrollList:BuildMasterList()
	self.masterList = {}
	if rltext.masterList then
		local units = raidplanner:GetVars().raids
		local data = {}

		for k, v in pairs(units) do
			table.insert(self.masterList, {["name"]=k})
		end
	end
end

function rpscrollList:FilterScrollList()
	local scrollData = ZO_ScrollList_GetDataList(self.list)
	ZO_ClearNumericallyIndexedTable(scrollData)

	for k, v in pairs(self.masterList) do
		local data = v --self.masterList[i]
		table.insert(scrollData, ZO_ScrollList_CreateDataEntry(1, data))
	end
end

function rpscrollList:SortScrollList()
end

function raidplanner:ScrollMouseEnter(control)
	raidplanner.scrollList:Row_OnMouseEnter(control)
	raidplanner.SelectedControl = control
end

function raidplanner:ScrollMouseExit(control)
	raidplanner.scrollList:Row_OnMouseExit(control)
	raidplanner.SelectedControl = nil
end

function raidplanner:OnLoadClick(self)
	if not raidplanner.SelectedControl then return end

	local data = raidplanner.SelectedControl.data

	local ntank = 0
	local ndps = 0
	local nheal = 0

	for k,v in ipairs(raidplanner:GetVars().raids[data.name]) do
		if v.role == 1 then
			ntank = ntank+1
		elseif v.role == 2 then
			ndps = ndps+1
		elseif v.role == 3 then
			nheal = nheal+1
		end
	end

	RLLoadRaidWindowInfo:SetText(data.name.."\n"..tostring(ntank).." TANK / "..tostring(ndps).." DPS / "..tostring(nheal).." HEAL")
end

rltext.module:Add(raidplanner)