
local readycheck = rltext.module:New()
readycheck.name = "ReadyCheck"
readycheck.isActive = false
readycheck.Players = {}
readycheck.id = 1


function readycheck:Init()
	local newVars = {}
	table.insert(newVars, {
		name = "readfor",
		value = "r,ready,rdy",
	})

	rltext.module:AddSavedVars(readycheck.name, newVars)


	local nButton = {}
	nButton.OnEnter = function(self) end
	nButton.OnLeave = function(self) end
	nButton.OnClicked = function(self) rltext.OnReadyCheckButton() end
	nButton.toolTip = "Toggle Ready Check"

	rltext.module:AddButton(readycheck.name, nButton)
end

function readycheck:Options()
	local optionsData = {}
	table.insert(optionsData, {
		type = 'editbox',
		name = "Listening On",
		tooltip = "What message to listen for. Seperate with \",\"",
		isMultiline = false,
		getFunc = function() return rltext.module:GetModuleVars(readycheck.name).readfor end,
		setFunc = function(value)
			rltext.module:GetModuleVars(readycheck.name).readfor = value
		end,
	})

	rltext.module:AddOptions(readycheck.name, optionsData)
end


function readycheck.OnChat(eventcode, messageType, messageFrom, messageText)
	if rltext.module:IsModuleDisabled(readycheck.name) then return end
	if not(rltext.module:GetVar(readycheck.name, "isActive")) then return end

	messageFrom = zo_strformat("<<t:1>>", messageFrom)
	local aName = messageFrom
	local readForVal = rltext.module:GetModuleVars(readycheck.name).readfor
	local rPlayers = rltext.module:GetVar(readycheck.name, "Players")
	local groupSize = GetGroupSize()
	local playersReady = #rPlayers

	readForVal = rltext.strsplit(readForVal, ",")


	if groupSize == playersReady then return end

	if messageType == 3 then
		for _k,_v in ipairs(readForVal) do
			if string.len(messageText) == string.len(_v) then
				if string.lower(messageText) == string.lower(_v) then
					if rltext.tableHasValue(rPlayers,aName) then return end

					if (playersReady+1) == groupSize then
						d("RLE-ReadyCheck: |c00FF00Everyone is Ready.|r")
						rltext.module:SetVar(readycheck.name, "isActive", false)
					else
						table.insert(rPlayers, aName)
						rltext.module:SetVar(readycheck.name, "Players", rPlayers)
						d("RLE-ReadyCheck: "..(playersReady+1).."/"..groupSize.." Ready.|r")
					end
					break
				end
			end
		end

	end
end

function readycheck.StartListening()
	local _isActive = rltext.module:GetVar(readycheck.name, "isActive")

	rltext.module:SetVar(readycheck.name, "isActive", not(_isActive))

	local pl = {}
	table.insert(pl, rltext.player)
	rltext.module:SetVar(readycheck.name, "Players", pl)

	if not(_isActive) then
		d("RLE-ReadyCheck: Ready to listen.")
	else
		d("RLE-ReadyCheck: Stopped listening.")
	end
end


EVENT_MANAGER:RegisterForEvent(rltext.name..readycheck.name, EVENT_CHAT_MESSAGE_CHANNEL, readycheck.OnChat)


rltext.module:Add(readycheck)